import Vue from 'vue';
import VComponent from 'vue-class-component';
import { mapState, mapGetters, mapActions, mapMutations } from 'vuex';
export declare const Component: typeof VComponent;
export declare type VuexDecorator = <V extends Vue>(proto: V, key: string) => void;
export declare type StateTransformer = (state: any, getters: any) => any;
export declare type MapHelper = typeof mapState | typeof mapGetters | typeof mapActions | typeof mapMutations | any;
export interface BindingOptions {
    namespace?: string;
    setKey?: string;
}
export interface BindingHelper {
    <V extends Vue>(proto: V, key: string): void;
    (type: string, options?: BindingOptions): VuexDecorator;
}
export interface StateBindingHelper extends BindingHelper {
    (type: StateTransformer, options?: BindingOptions): VuexDecorator;
}
export interface SetterBindingHelper extends BindingHelper {
    (type: string, options?: BindingOptions | string): VuexDecorator;
}
export interface BindingHelpers {
    State: StateBindingHelper;
    Getter: BindingHelper;
    Mutation: BindingHelper;
    Action: BindingHelper;
    GetterSetter: SetterBindingHelper;
}
export declare const State: StateBindingHelper;
export declare const Getter: BindingHelper;
export declare const Action: BindingHelper;
export declare const Mutation: BindingHelper;
export declare const GetterSetter: SetterBindingHelper;
export declare function namespace(namespace: string): BindingHelpers;
export declare function namespace<T extends BindingHelper>(namespace: string, helper: T): T;
